#include "mainwindow.h"
#include <QApplication>

#include <QWebView>
#include <QProcess>
#include <QObject>
#include <QtWebKit>

int main(int argc, char *argv[])
{
    QApplication a(argc, argv);
    QMainWindow w;
    w.resize(QSize(1000, 800));

    // Start child process
    QProcess webProcess;
    webProcess.start("WEB-AccessUxdbAdmin.exe", QStringList() << "http://127.0.0.1:5050");
    // WEB-AccessUxdbAdmin.exe是外部程序，"http://127.0.0.1:5050"是传入的参数，若不需要参数可改为空""

    qDebug() << "Starting WEB-AccessUxdbAdmin...";

    // Get child process handle
    WId childId = (WId)FindWindow(NULL, L"WEB-AccessUxdbAdmin");
    int n = 0;
    while (true) {
        Sleep(1);
        childId = (WId)FindWindow(NULL, L"WEB-AccessUxdbAdmin");
        if (childId != 0) {
            break;
        } else if(n++ > 5000) {
            return 1;
        }
    }
    HWND childHwnd = (HWND)childId;

    // Put the child window in front first, and then put it back
    SetWindowPos(childHwnd,HWND_TOP,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE);
    SetWindowPos(childHwnd,HWND_BOTTOM,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE);

    // Get the parent window's geometry
    QRect rt = w.geometry();

    // Get the child window object by id
    QWindow *childWd;
    childWd = QWindow::fromWinId(childId);

    // Set child window geometry
    childWd->setGeometry(rt);

    // Get parent process handle
    WId parentId = w.winId();
    HWND parentHwnd = (HWND)parentId;

    // Embedding child window into parent window
    SetParent(childHwnd, parentHwnd);

    // Display parent window
    w.show();

    return a.exec();
}
